## ausaxs 1.1.8

=== CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

cmake_minimum_required(VERSION 3.15)
project(AUSAXS VERSION 1.1.8)
option(GUI "Enable GUI executables" OFF)
option(DLIB "Download and use the dlib minimizers" ON)
option(BUILD_PLOT_EXE "Compile the plotting utility as an executable for the current platform" OFF)
option(CONSTEXPR_TABLES "Generate lookup tables at compile-time" OFF)
set(ARCH "native" CACHE STRING "Target architecture. Default: native")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
add_compile_definitions("CONSTEXPR_TABLES=${CONSTEXPR_TABLES};$<$<CONFIG:DEBUG>:DEBUG=1;SAFE_MATH=1>")
if (WIN32)
	if (MSVC)
		add_compile_definitions("NOMINMAX;BUILD_EXPORT_DLL")
		add_compile_options(
			/fp:fast /constexpr:steps10000000000 /Zm500 
			/wd4267 # disable size_t --> int, unsigned int conversions
			/wd4244 # disable double --> float,int conversions
			"$<$<STREQUAL:${ARCH},x86-64>:/arch:AVX>"
			"$<$<STREQUAL:${ARCH},arm64>:/arch:armv8.0>"
		)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
		set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
	elseif (MINGW)
		add_compile_options(
			-O3 -ffast-math -fno-finite-math-only -pipe -mavx
			"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},Clang>:-fconstexpr-steps=1000000000>"
			"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},GNU>:-fconstexpr-ops-limit=10000000000>"
			"$<$<CONFIG:DEBUG>:-g;-Wall;-Wpedantic;-Wextra;-march=native>"
			"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},x86-64>>:-march=x86-64-v3>"
			"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},native>>:-march=native>"
		)
	endif()
elseif (APPLE)
	add_compile_options(
		-O3 -ffast-math -fno-finite-math-only -pipe 
		"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},Clang>:-fconstexpr-steps=1000000000>"
		"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},GNU>:-fconstexpr-ops-limit=10000000000>"
		"$<$<CONFIG:DEBUG>:-g;-Wall;-Wpedantic;-Wextra>"
		"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},x86-64>>:-march=x86-64>"
		"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},arm64>>:-march=armv8-a>"
	)
elseif (UNIX)
#	add_compile_definitions("$<$<CONFIG:DEBUG>:_GLIBCXX_DEBUG>")
	add_compile_options(
		-Ofast -fno-finite-math-only -pipe -mavx
		"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},Clang>:-fconstexpr-steps=1000000000>"
		"$<$<STREQUAL:${CMAKE_CXX_COMPILER_ID},GNU>:-fconstexpr-ops-limit=10000000000>"
		"$<$<CONFIG:DEBUG>:-g;-Wall;-Wpedantic;-Wextra;-march=native>"
		"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},x86-64>>:-march=x86-64-v3>"
		"$<$<AND:$<CONFIG:RELEASE>,$<STREQUAL:${ARCH},native>>:-march=native>"
	)
endif()

############################################
##      Temporary External Library Fixes ##
############################################
# TODO: Remove once dlib fixes the missing template argument issue
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "17.0")
    add_compile_options(-Wno-error=missing-template-arg-list-after-template-kw)
endif()

############################################
##            Dependencies                ##
############################################
include(FetchContent)
set(FETCHCONTENT_UPDATES_DISCONNECTED ON)
get_property(
    compile_options
    DIRECTORY
    PROPERTY COMPILE_OPTIONS
)

set_property(
    DIRECTORY
    APPEND
    PROPERTY COMPILE_OPTIONS -w
)

if (DLIB)
	FetchContent_Declare(
		dlib
		GIT_REPOSITORY https://github.com/davisking/dlib
		GIT_TAG v19.24.4
		GIT_PROGRESS TRUE
	)

	# tell dlib not to link with various unnecessary libraries
	set(DLIB_NO_GUI_SUPPORT TRUE)
	set(DLIB_JPEG_SUPPORT OFF)
	set(DLIB_LINK_WITH_SQLITE3 OFF)
	set(DLIB_USE_BLAS OFF)
	set(DLIB_USE_LAPACK OFF)
	set(DLIB_USE_CUDA OFF)
	set(DLIB_PNG_SUPPORT OFF)
	set(DLIB_GIF_SUPPORT OFF)
	set(DLIB_WEBP_SUPPORT OFF)
	set(DLIB_JXL_SUPPORT OFF)
	set(DLIB_USE_FFTW OFF)
	set(DLIB_USE_MKL_FFT OFF)
	set(DLIB_USE_FFMPEG OFF)
	set(CMAKE_CXX_STANDARD 17) # dlib must be compiled with C++17
	FetchContent_MakeAvailable(dlib)
	set(CMAKE_CXX_STANDARD 20) # continue with C++20	
	add_compile_definitions("DLIB_AVAILABLE")
endif()

FetchContent_Declare(
	backward
	GIT_REPOSITORY https://github.com/bombela/backward-cpp
)

FetchContent_Declare(
	thread_pool
	GIT_REPOSITORY https://github.com/bshoshany/thread-pool
)

FetchContent_Declare(
	gcem
	GIT_REPOSITORY https://github.com/klytje/gcem
)

set_property(
    DIRECTORY
    PROPERTY COMPILE_OPTIONS ${compile_options}
)
unset(compile_options)

FetchContent_MakeAvailable(thread_pool GCEM backward)
include_directories(${thread_pool_SOURCE_DIR}/include ${gcem_SOURCE_DIR}/include ${backward_SOURCE_DIR})

############################################
##           Find and link CURL           ##
############################################
if (WIN32)
	add_compile_definitions("CURL_STATICLIB")
	find_package(CURL REQUIRED)
	set(LIBS -static CURL::libcurl)
	include_directories(${CURL_INCLUDE_DIRS}) # find_package apparently does not always include the headers
elseif (APPLE)
	find_package(CURL REQUIRED)
	set(LIBS CURL::libcurl)
	link_libraries("$<$<CONFIG:Debug>:-ldwarf>")
elseif(UNIX)
	find_package(CURL REQUIRED)
	set(LIBS CURL::libcurl -static-libgcc -static-libstdc++)
	link_libraries("$<$<CONFIG:Debug>:-ldwarf>")
endif()
############################################
##                Doxygen                 ##
############################################
find_package(Doxygen)
if (DOXYGEN_FOUND)
	set(sim3a_Doxygen "${CMAKE_BINARY_DIR}/saxs.dox")
	configure_file(${CMAKE_SOURCE_DIR}/scripts/ausaxs.dox.in ${sim3a_Doxygen} @ONLY)
	add_custom_target(
		doc
		${DOXYGEN_EXECUTABLE} ${sim3a_Doxygen}
    		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    		COMMENT "Generating API documentation with Doxygen" VERBATIM
	)
endif()


############################################
##           Build library                ##
############################################
if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
	include(CheckIPOSupported)
	check_ipo_supported(RESULT LTO_SUPPORTED)
else()
	set(LTO_SUPPORTED OFF)
endif()

add_subdirectory(source)
add_subdirectory(tests)
add_subdirectory(executable)

=== executable/CMakeLists.txt ===
FetchContent_Declare(
	CLI11
	GIT_REPOSITORY https://github.com/CLIUtils/CLI11
	GIT_TAG 792d89286788acac125e0487f8dbde88035f7422
	GIT_PROGRESS TRUE
)
FetchContent_MakeAvailable(CLI11)

# helper function to attach post-build copy of plotting scripts to an executable target.
function(add_plot_scripts_to_target _target)
	if (NOT TARGET ${_target})
		message(WARNING "add_plot_scripts_to_target: target ${_target} does not exist")
		return()
	endif()

	add_custom_command(TARGET ${_target} POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E make_directory $<TARGET_FILE_DIR:${_target}>
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_SOURCE_DIR}/scripts/plot.py $<TARGET_FILE_DIR:${_target}>/plot.py
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_SOURCE_DIR}/scripts/plot_helper.py $<TARGET_FILE_DIR:${_target}>/plot_helper.py
		COMMENT "Copying plotting scripts to runtime directory for ${_target}"
	)
endfunction()

add_executable(saxs_fitter "saxs_fitter.cpp")
add_executable(em_fitter "em_fitter.cpp")
add_executable(rigidbody_optimizer "rigidbody_optimizer.cpp")

target_link_libraries(saxs_fitter PRIVATE ausaxs_core ausaxs_math CLI11::CLI11)
target_link_libraries(em_fitter PRIVATE ausaxs_core ausaxs_math ausaxs_em CLI11::CLI11)
target_link_libraries(rigidbody_optimizer PRIVATE ausaxs_core ausaxs_math ausaxs_rigidbody CLI11::CLI11)

add_plot_scripts_to_target(saxs_fitter)
add_plot_scripts_to_target(em_fitter)
add_plot_scripts_to_target(rigidbody_optimizer)

if (GUI)
	add_subdirectory(gui)
endif()

=== source/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(crystal)
add_subdirectory(em)
add_subdirectory(math)
add_subdirectory(rigidbody)
add_subdirectory(gui)

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "")
if (MSVC)
	set(CMAKE_CXX_FLAGS_TEST "/O2 /W4 /permissive- /EHsc")
	set(CMAKE_CXX_FLAGS "/EHsc")
else()
	set(CMAKE_CXX_FLAGS_TEST
		"-Os -Wpedantic -Wall -Wextra -Wno-nested-anon-types"
		CACHE STRING "Flags used by the C++ compiler during test builds."
	)
endif()

set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL TRUE)

include(FetchContent)
FetchContent_Declare(
	Catch2
	GIT_REPOSITORY https://github.com/catchorg/Catch2.git
	GIT_TAG 914aeecfe23b1e16af6ea675a4fb5dbd5a5b8d0a
	GIT_PROGRESS TRUE
)
FetchContent_MakeAvailable(Catch2)

# make the tests available through CTest
list(APPEND CMAKE_MODULE_PATH ${catch2_SOURCE_DIR}/extras)
include(CTest)
include(Catch)

add_subdirectory(unit)
add_subdirectory(feature)
add_subdirectory(benchmark)

add_custom_target(tests DEPENDS unit_tests feature_tests)

=== executable/gui/CMakeLists.txt ===
FetchContent_Declare(
	elements
	GIT_REPOSITORY https://github.com/cycfi/elements.git
)
FetchContent_Declare(
	nfd
	GIT_REPOSITORY https://github.com/btzy/nativefiledialog-extended.git
)
FetchContent_MakeAvailable(elements CLI11 nfd)

# set the path to the elements root & module path
set(ELEMENTS_ROOT "${elements_SOURCE_DIR}")
set(ELEMENTS_BUILD_EXAMPLES OFF)
get_filename_component(ELEMENTS_ROOT "${ELEMENTS_ROOT}" ABSOLUTE)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${ELEMENTS_ROOT}/cmake")

# target for ensuring plotting is possible for the gui executables
add_custom_target(plotter)
if (${BUILD_PLOT_EXE})
	find_package(Python3 COMPONENTS Interpreter)
	if (Python3_FOUND)
		execute_process(
			COMMAND pip show pyinstaller matplotlib numpy
			RESULT_VARIABLE EXIT_CODE
			OUTPUT_QUIET
		)
		if (${EXIT_CODE} EQUAL 0)
		  add_custom_command(TARGET plotter POST_BUILD
				COMMAND ${Python3_EXECUTABLE} -c "import PyInstaller.__main__; PyInstaller.__main__.run(['${CMAKE_SOURCE_DIR}/scripts/plot.py', '--onefile', '--distpath', '${CMAKE_RUNTIME_OUTPUT_DIRECTORY}'])"
				VERBATIM
			)
		elseif(${GUI})
			message(FATAL_ERROR "GUI executables requested, but Python is not installed. The plotting script is unusable. Compile using GUI=FALSE to avoid this error.")
		else()
			message(WARNING "The plotting utility cannot be built. The GUI executables will only be able to use the raw Python scripts.")
		endif()
	endif()
endif()

# gui executables
add_subdirectory(saxs_fitter_gui)
add_subdirectory(em_fitter_gui)

=== source/core/CMakeLists.txt ===
add_library(ausaxs_core OBJECT)
set_target_properties(ausaxs_core PROPERTIES POSITION_INDEPENDENT_CODE 1)
target_include_directories(ausaxs_core PUBLIC "${CMAKE_SOURCE_DIR}/include/core")
target_link_libraries(ausaxs_core ausaxs_math CURL::libcurl)
if (DLIB) 
	target_link_libraries(ausaxs_core "dlib::dlib") 
endif()

add_library(ausaxs_static STATIC $<TARGET_OBJECTS:ausaxs_core>)
target_include_directories(ausaxs_static PUBLIC "${CMAKE_SOURCE_DIR}/include/core")
set_target_properties(ausaxs_static PROPERTIES 
	OUTPUT_NAME ausaxs_static
	INTERPROCEDURAL_OPTIMIZATION ${LTO_SUPPORTED}
)
add_library(ausaxs SHARED $<TARGET_OBJECTS:ausaxs_core>)
target_include_directories(ausaxs PUBLIC "${CMAKE_SOURCE_DIR}/include/core")
set_target_properties(ausaxs 
	PROPERTIES OUTPUT_NAME ausaxs
	INTERPROCEDURAL_OPTIMIZATION ${LTO_SUPPORTED}
)

# windows-specific option to ensure DLL is located in /lib
set_target_properties(ausaxs PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
	RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_BINARY_DIR}/lib
	RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_BINARY_DIR}/lib
)

target_link_libraries(ausaxs ausaxs_core ausaxs_math ausaxs_em ausaxs_rigidbody)
target_link_libraries(ausaxs_static ausaxs_core ausaxs_math ausaxs_em ausaxs_rigidbody)

add_subdirectory(api)
add_subdirectory(constants)
add_subdirectory(data)
add_subdirectory(dataset)
add_subdirectory(fitter)
add_subdirectory(form_factor)
add_subdirectory(grid)
add_subdirectory(hist)
add_subdirectory(hydrate)
add_subdirectory(io)
add_subdirectory(mini)
add_subdirectory(plots)
add_subdirectory(residue)
add_subdirectory(settings)
add_subdirectory(shell)
add_subdirectory(table)
add_subdirectory(utility)

=== source/crystal/CMakeLists.txt ===
add_library(ausaxs_crystal OBJECT 
	"CrystalScattering.cpp"
	"Fval.cpp"

	"io/CrystalReaderFactory.cpp"
	"io/GridReader.cpp"
	"io/PDBReader.cpp"
	"io/UnitCellReader.cpp"

	"miller/AllMillers.cpp"
	"miller/FibonacciMillers.cpp"
	"miller/Miller.cpp"
	"miller/MillerGenerationFactory.cpp"
	"miller/ReducedMillers.cpp"
)

target_include_directories(ausaxs_crystal PUBLIC "${CMAKE_SOURCE_DIR}/include/crystal")
target_link_libraries(ausaxs_crystal PRIVATE ausaxs_core ausaxs_math)
set_target_properties(ausaxs_crystal PROPERTIES POSITION_INDEPENDENT_CODE 1)

=== source/em/CMakeLists.txt ===
add_library(ausaxs_em OBJECT 
	"Image.cpp"
	"ImageStack.cpp"
	"ObjectBounds2D.cpp"
	"ObjectBounds3D.cpp"

	"detail/ImageStackBase.cpp"
	"detail/EMFitResult.cpp"
	"detail/EMGrid.cpp"
	"detail/header/DummyHeader.cpp"
	"detail/header/HeaderFactory.cpp"
	"detail/header/MapHeader.cpp"
	"detail/header/MRCHeader.cpp"
	"detail/header/RECHeader.cpp"
	"detail/header/data/HeaderData.cpp"
	"detail/header/data/MRCData.cpp"
	"detail/header/data/RECData.cpp"

	"manager/ProteinManager.cpp"
	"manager/ProteinManagerFactory.cpp"
	"manager/SimpleProteinManager.cpp"
	"manager/SmartProteinManager.cpp"

	"plots/PlotImage.cpp"
)

target_include_directories(ausaxs_em PUBLIC "${CMAKE_SOURCE_DIR}/include/em")
target_link_libraries(ausaxs_em ausaxs_core)
set_target_properties(ausaxs_em PROPERTIES POSITION_INDEPENDENT_CODE 1)

=== source/gui/CMakeLists.txt ===
add_library(ausaxs_gui OBJECT 
	"plotting.cpp"
	"resources.cpp"
)

target_include_directories(ausaxs_gui PUBLIC "${CMAKE_SOURCE_DIR}/include/gui")
target_link_libraries(ausaxs_gui PRIVATE ausaxs_core ausaxs_math)
set_target_properties(ausaxs_gui PROPERTIES POSITION_INDEPENDENT_CODE 1)

=== source/math/CMakeLists.txt ===
add_library(ausaxs_math OBJECT 
	"CubicSpline.cpp"
	"LUPDecomposition.cpp"
	"MatrixUtils.cpp"
	"MovingAverager.cpp"
	"PeakFinder.cpp"
)

target_include_directories(ausaxs_math PUBLIC "${CMAKE_SOURCE_DIR}/include/math")
set_target_properties(ausaxs_math PROPERTIES POSITION_INDEPENDENT_CODE 1)

=== source/rigidbody/CMakeLists.txt ===
add_library(ausaxs_rigidbody OBJECT 
	"RigidBody.cpp"
	"BodySplitter.cpp"

	"constraints/Constraint.cpp"
	"constraints/ConstraintManager.cpp"
	"constraints/DistanceConstraint.cpp"
	"constraints/FixedConstraint.cpp"
	"constraints/LinkConstraint.cpp"
	"constraints/OverlapConstraint.cpp"
	"constraints/generation/ConstraintGenerationFactory.cpp"
	"constraints/generation/ConstraintGenerationStrategy.cpp"
	"constraints/generation/LinearConstraints.cpp"
	"constraints/generation/NoConstraints.cpp"
	"constraints/generation/VolumetricConstraints.cpp"

	"detail/BestConf.cpp"
	
	"parameters/ParameterGenerationFactory.cpp"
	"parameters/ParameterGenerationStrategy.cpp"
	"parameters/decay/DecayFactory.cpp"
	"parameters/decay/ExponentialDecay.cpp"
	"parameters/decay/LinearDecay.cpp"

	"selection/BodySelectFactory.cpp"
	"selection/BodySelectStrategy.cpp"
	"selection/ManualSelect.cpp"
	"selection/RandomBodySelect.cpp"
	"selection/RandomConstraintSelect.cpp"
	"selection/SequentialBodySelect.cpp"
	"selection/SequentialConstraintSelect.cpp"

	"sequencer/BodySelectElement.cpp"
	"sequencer/ConstraintIteratorElement.cpp"
	"sequencer/ConstraintIteratorElementCallback.cpp"
	"sequencer/EveryNStepElement.cpp"
	"sequencer/LoopElement.cpp"
	"sequencer/LoopElementCallback.cpp"
	"sequencer/OnImprovementElement.cpp"
	"sequencer/OptimizeStepElement.cpp"
	"sequencer/ParameterElement.cpp"
	"sequencer/ParameterElementCallback.cpp"
	"sequencer/SaveElement.cpp"
	"sequencer/Sequencer.cpp"
	"sequencer/TransformElement.cpp"
	"sequencer/detail/SequenceParser.cpp"
	"sequencer/setup/AutoConstraintsElement.cpp"
	"sequencer/setup/ConstraintElement.cpp"
	"sequencer/setup/LoadElement.cpp"
	"sequencer/setup/LoadExistingElement.cpp"
	"sequencer/setup/RelativeHydrationElement.cpp"
	"sequencer/setup/SetupElement.cpp"
	"sequencer/setup/SymmetryElement.cpp"
	
	"transform/RigidTransform.cpp"
	"transform/SingleTransform.cpp"
	"transform/TransformFactory.cpp"
	"transform/TransformGroup.cpp"
	"transform/TransformStrategy.cpp"
)

target_include_directories(ausaxs_rigidbody PUBLIC "${CMAKE_SOURCE_DIR}/include/rigidbody")
target_link_libraries(ausaxs_rigidbody ausaxs_core)
set_target_properties(ausaxs_rigidbody PROPERTIES POSITION_INDEPENDENT_CODE 1)

=== tests/benchmark/CMakeLists.txt ===
# Benchmark tests for performance evaluation
# Run with: cmake --build build --target benchmark_tests && ./build/tests/benchmark/bin/benchmark_tests

set(BENCHMARK_TEST_SOURCES
    distance_calculation_benchmark.cpp
)

add_executable(benchmark_tests ${BENCHMARK_TEST_SOURCES} ${CMAKE_SOURCE_DIR}/tests/settings.cpp)

target_link_libraries(benchmark_tests
    PRIVATE
        ausaxs
        Catch2::Catch2WithMain
)

target_include_directories(benchmark_tests
    PRIVATE
        ${CMAKE_SOURCE_DIR}/include
        ${CMAKE_SOURCE_DIR}/tests
)

set_target_properties(benchmark_tests PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin
)

# Don't run benchmarks as part of regular CTest - they're for manual performance testing
# catch_discover_tests(benchmark_tests)

=== debian/changelog ===
ausaxs (1.1.8-1) unstable; urgency=low

  * Initial release of ausaxs library for pyAUSAXS Python module.

 -- Stuart Prescott <stuart@debian.org>  Mon, 19 Jan 2026 17:17:39 +1100

=== debian/control ===
Source: ausaxs
Section: libs
Maintainer: Stuart Prescott <stuart@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen,
 libbackward-cpp-dev,
 libcairo2-dev,
 libcatch2-dev,
 libcli11-dev,
 libcurl4-openssl-dev,
 libgcem-dev,
 libgtk-3-dev,
 libbs-thread-pool-dev,
 libwebp-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/AUSAXS/AUSAXS/
Vcs-Git: https://salsa.debian.org/science-team/ausaxs.git
Vcs-Browser: https://salsa.debian.org/science-team/ausaxs

Package: libausaxs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: AUSAXS scattering calculator library
 The AUSAXS library is a calculation engine for evaluating the scattering
 intensity of biological samples and crystals. The calculations are
 based on the Debye equation and the library can be used to fit
 high-resolution models to SAXS curves, with options for the handling of
 both the excluded volume and hydration shell.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
          -DGUI=OFF \
          -DDLIB=OFF \
          -DUSE_SYSTEM_GCEM=ON \
          -DUSE_SYSTEM_BACKWARD=ON \
          -DUSE_SYSTEM_CLI11=ON \
          -DUSE_SYSTEM_THREADPOOL=ON \
          -DUSE_SYSTEM_CATCH=ON

override_dh_auto_build:
	dh_auto_build -- \
          ausaxs saxs_fitter em_fitter rigidbody_optimizer

override_dh_auto_install:
	# We might install these tools in a separate package, one day..
	# mkdir -p $(CURDIR)/debian/ausaxs/usr/bin
	# cp -v obj*/bin/saxs_fitter obj*/bin/em_fitter obj*/bin/rigidbody_optimizer $(CURDIR)/debian/ausaxs/usr/bin/

	mkdir -p $(CURDIR)/debian/libausaxs/usr/lib/ausaxs/
	cp -v obj*/lib/libausaxs.so $(CURDIR)/debian/libausaxs/usr/lib/ausaxs

	# Not yet a library that other things will compile against, one day...
	# mkdir -p $(CURDIR)/debian/libausaxs-dev/usr/include/$(DEB_HOST_MULTIARCH)/
	# cp -rv include/core/api $(CURDIR)/debian/libausaxs-dev/usr/include/$(DEB_HOST_MULTIARCH)/
